%global flavor gcc32

%global __strip %{_mingw32_strip}
%global __objdump %{_mingw32_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{_mingw32_findrequires}
%global __find_provides %{_mingw32_findprovides}
%define __debug_install_post %{_mingw32_debug_install_post}

%global oname globus-common
%global _name %(tr - _ <<< %{oname})

Name:		mingw32-%{oname}
Version:	14.5
Release:	1%{?dist}
Summary:	Globus Toolkit for MinGW - Common Library

Group:		Development/Libraries
License:	ASL 2.0
URL:		http://www.globus.org/
Source:		http://www.globus.org/ftppub/gt5/5.2/5.2.0/packages/src/%{_name}-%{version}.tar.gz
Patch0:		%{oname}-initializers.patch
Patch1:		%{oname}-format.patch
Patch2:		%{oname}-doxygen.patch
Patch3:		%{oname}-sh-env.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

#		Keep providing mingw32-globus-common-setup until not needed
Provides:	%{name}-setup = 2.6
Requires:	mingw32-globus-core >= 8
#		Obsolete dropped packages from Globus Toolkit 5.2.0
Provides:	mingw32-globus-libtool = 2
Obsoletes:	mingw32-globus-libtool < 2
Provides:	mingw32-globus-openssl = 6
Obsoletes:	mingw32-globus-openssl < 6
BuildRequires:	grid-packaging-tools >= 3.4
BuildRequires:	mingw32-globus-core >= 8
BuildRequires:	mingw32-filesystem
BuildRequires:	mingw32-gcc
BuildRequires:	mingw32-dlfcn
BuildRequires:	mingw32-libltdl

%description
The Globus Toolkit is an open source software toolkit used for building Grid
systems and applications. It is being developed by the Globus Alliance and
many others all over the world. A growing number of projects and companies are
using the Globus Toolkit to unlock the potential of grids for their cause.

The %{name} package contains:
Common Library

%{?_mingw32_debug_package}

%prep
%setup -q -n %{_name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
export GPT_LOCATION=%{_prefix}
export GLOBUS_LOCATION=%{_mingw32_prefix}

# Remove files that should be replaced during bootstrap
rm -f doxygen/Doxyfile*
rm -f doxygen/Makefile.am
rm -f pkgdata/Makefile.am
rm -f globus_automake*
rm -rf autom4te.cache

%{_mingw32_datadir}/globus/globus-bootstrap.sh

# Configure gets these wrong for mingw
export ac_cv_func_gethostbyname=yes
export lac_cv_lsocket=no
export lac_cv_lnsl=no

# External windows libraries
export EXTERNAL_LIBS="-liphlpapi -lws2_32"

export GLOBUS_VERSION=5.2.0
%_mingw32_configure --disable-static --with-flavor=%{flavor} \
		    --with-docdir=%{_mingw32_docdir}/%{name}-%{version}
find . -name Makefile -exec sed 's/^LDFLAGS =/& -no-undefined/' -i {} ';'

make %{?_smp_mflags}

%install
export GLOBUS_LOCATION=%{_mingw32_prefix}

rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

GLOBUSPACKAGEDIR=$RPM_BUILD_ROOT%{_mingw32_datadir}/globus/packages

# These scripts are intended to be sourced, not executed
chmod 644 $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/globus-args-parser-header
chmod 644 $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/globus-script-initializer
chmod 644 $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/globus-sh-tools.sh

# Create setup directories
mkdir $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/packages/setup
mkdir $RPM_BUILD_ROOT%{_mingw32_datadir}/globus/setup

# Generate package filelists
cat $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_rtl.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_pgm.filelist \
    $GLOBUSPACKAGEDIR/%{_name}/%{flavor}_dev.filelist \
  | sed s!^!%{_mingw32_prefix}! > package.filelist
cat $GLOBUSPACKAGEDIR/%{_name}/noflavor_doc.filelist \
  | sed -e 's!/man/.*!&*!' -e 's!^!%doc %{_mingw32_prefix}!' >> package.filelist

%clean
rm -rf $RPM_BUILD_ROOT

%files -f package.filelist
%defattr(-,root,root,-)
%dir %{_mingw32_datadir}/globus/packages/%{_name}
%dir %{_mingw32_datadir}/globus/packages/setup
%dir %{_mingw32_datadir}/globus/setup
%dir %{_mingw32_libdir}/perl
%dir %{_mingw32_libdir}/perl/Globus
%dir %{_mingw32_libdir}/perl/Globus/Core
%dir %{_mingw32_includedir}/globus
%{_mingw32_bindir}/libglobus_common-0.dll
%{_mingw32_libdir}/libglobus_thread_pthread-0.dll
%{_mingw32_libdir}/libglobus_thread_windows-0.dll
%dir %{_mingw32_docdir}/%{name}-%{version}

%changelog
* Sun Feb 05 2012 Mattias Ellert <mattias.ellert@fysast.uu.se> - 14.5-1
- Update to Globus Toolkit 5.2.0

* Wed Jun 22 2011 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.6-1
- Update to Globus Toolkit 5.0.3

* Sat Jul 17 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.5-1
- Update to Globus Toolkit 5.0.2

* Mon May 03 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.4-1
- Update to Globus Toolkit 5.0.1

* Wed Mar 10 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.2-2
- Add debug package

* Sun Mar 07 2010 Mattias Ellert <mattias.ellert@fysast.uu.se> - 11.2-1
- Update to Globus Toolkit 5.0.0

* Wed May 06 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 10.2-1
- Autogenerated
